Subject: RESTful NodeController for easy comment creation
Description

As a site integrator I want a RESTful NodeController in order to create blog post comments by just coding a Fluid-based form.

DoD
 - POST request on ...../blog/posts/my-blog-post/comments creates a new comment
 - properties are validated (HTML not allowed in post comment (Note: we don't support markup at all -> htmlspecialchars) email
address required)
 - on validation error the user is returned to the original page with the form values still filled in and an error message displayed
 - NodeController also handles other types of content, for example Page

Subtasks:
Task # 44918: NodeTemplateConverter Resolved
Task # 44917: Add support for transient nodes Resolved
Related issues:
related to Base Distribution - Work Package # 45088: Improved REST support Resolved 2011-05-29 2013-04-13

History
#1 - 2013-01-29 15:09 - Robert Lemke
- Subject changed from As site integrator I want a RESTful NodeController in order to create comments  to RESTful NodeController for easy comment 
creation
- Position deleted (1)
- Position set to 1

#2 - 2013-01-29 15:14 - Robert Lemke
- Category set to Content Management
- Assigned To set to Bastian Waidelich

#3 - 2013-01-29 15:20 - Bastian Waidelich
- Status changed from New to Accepted

#4 - 2013-05-06 13:59 - Bastian Waidelich

FYI: Technically this is quite easy to achieve with a new action in Frontend\NodeController:

1public function createAction(PersistentNodeInterface $parentNode, NodeTemplate $newNode) {
2    $createdNode = $parentNode->createNodeFromTemplate($newNode);
3    $this->redirect('show', NULL, NULL, array('node' => $createdNode));
4}

In conjunction with #27117 this should already work.
The problem: Security!
Obviously not Everybody should be able to create nodes. Also we can't restrict this to authenticated users (this would not work for the described
scenario where anonymous users are allowed to post comments).

For this to be implemented we probably need some kind of "node restrictions" (e.g. nodes of type X can only be inserted below some/path by role Y).
At some point we need that anyways for Neos..

#5 - 2013-05-06 14:17 - Adrian Föder

at least

nodes of type X

could be implemented with something like a (todo) instanceof runtime constraint operator which would be useful to have anyways.

Or, the runtime constraint handling will have a new feature where arguments must satisfy particular, more fine grained checks, just like
1resources:
2  methods:
3    Foo_Bar_FooBar: 'method(Foo\Bar->SomeAction(product.owner = current.securityContext.party && newNode instanceof
Acme\Foobar\Node\CommentTemplate && parentNode satisfies Acme\Foobar\Constraint\CommentNodeCreationConstraint))
4

the product.owner part is what we already know; the instanceof would be the mentioned operator which checks for the argument being instanceof the
given class/interface (just like within); and the last one would be something like the mentioned user-definable constraint satisfaction.

#6 - 2013-05-16 12:10 - Bastian Waidelich
- Target version deleted (Sprint February 2013)

Adrian Föder wrote:

nodes of type X

could be implemented with something like a (todo) instanceof runtime constraint operator which would be useful to have anyways.

Right, we need those node constraints anyways (e.g. to have something like: "only allow Content Elements XY.. in section Z"). But we won't have that
in 1.0 unfortunately..

BTW: This is not only about authenticated users: If you want to have comment nodes for example (as Robert uses it in his blog) we want to allow 
Everybody to create *Comment*Nodes underneath a specified path

#7 - 2013-05-31 11:49 - Bastian Waidelich
- Status changed from Accepted to On Hold
- Assigned To deleted (Bastian Waidelich)

Set the status to "on hold" according to the missing constraint features mentioned above
